%bcond_with enable_perl_object_hashbase_tools
%global __requires_exclude ^perl\\(Test::More\\)$|^perl\\(Object::HashBase::Test::HBase.*

Summary:        Build hash-based classes
Name:           perl-Object-HashBase
Version:        0.010
Release:        1%{?dist}
License:        GPL+ or Artistic
URL:            https://metacpan.org/release/Object-HashBase
Source0:        https://cpan.metacpan.org/authors/id/E/EX/EXODIST/Object-HashBase-%{version}.tar.gz
Patch3000:      Object-HashBase-0.008-Normalize-shebang.patch

BuildRequires:  make
BuildRequires:  perl-generators
BuildRequires:  perl-interpreter
BuildRequires:  perl(:VERSION)
BuildRequires:  perl(strict)
BuildRequires:  perl(warnings)
BuildRequires:  perl(ExtUtils::MakeMaker) >= 6.76
BuildRequires:  perl(base)
BuildRequires:  perl(Carp)
BuildRequires:  perl(Test::More) >= 0.98
BuildRequires:  perl(vars)
# Tests:
BuildRequires:  perl(File::Temp)
BuildArch:      noarch

%description
This package is used to generate classes based on hash references. Using this
class will give you a new() method, as well as generating accessors you request.  
Generated accessors will be getters, set_ACCESSOR setters will also be generated 
for you. You also get constants for each accessor (all caps) which return the 
key into the hash for that accessor. Single inheritance is also supported.

%if %{with enable_perl_object_hashbase_tools}
%package tools
Summary:        Generate inlined Object::HashBase Perl module
Requires:       %{name} = %{version}-%{release}
Requires:       perl(Test::More) >= 0.98

%description tools
hashbase_inc.pl script generates a Perl module that contains
a Object::HashBase module mangled into a name space of your choice. It can
also generate the tests for it.
%endif

%prep
%autosetup -n Object-HashBase-%{version} -p1

%build
perl Makefile.PL INSTALLDIRS=vendor NO_PACKLIST=1 NO_PERLLOCAL=1
%make_build

%install
%make_install
%{_fixperms} -c %{buildroot}
%if %{without enable_perl_object_hashbase_tools}
rm -f %{buildroot}%{_bindir}/hashbase_inc.pl
rm -f %{_mandir}/man3/Object::HashBase::* 
rm -rf %{perl_vendorlib}/Object/HashBase
%endif

%check
make test

%files
%license LICENSE
%doc Changes README
%{perl_vendorlib}/*
%exclude %{perl_vendorlib}/Object/HashBase
%{_mandir}/man3/*
%exclude %{_mandir}/man3/Object::HashBase::*

%if %{with enable_perl_object_hashbase_tools}
%files tools
%{_bindir}/hashbase_inc.pl
%{perl_vendorlib}/Object/HashBase
%{_mandir}/man3/Object::HashBase::*
%endif

%changelog
* Thu Dec 21 2023 Upgrade Robot <upbot@opencloudos.org> - 0.010-1
- Upgrade to version 0.010

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.009-5
- Rebuilt for OpenCloudOS Stream 23.09

* Wed Aug 16 2023 Xiaojie Chen <jackxjchen@tencent.com> - 0.009-4
- Remove perl(:MODULE_COMPAT) which will be generated by perl-generators >= 1.15

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.009-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.009-2
- Rebuilt for OpenCloudOS Stream 23

* Mon Oct 31 2022 Xiaojie Chen <jackxjchen@tencent.com> - 0.009-1
- Initial build
